/*{ cc1101::.c ************************************************

 Program Name: cc1101


 Copyright:    <Sascha Poggemann>. All Rights Reserved.

 Description: This is an implementation for the Texas Instruments CC1101 Tranceiver

******************************************************

 $Author: <Sascha Poggemann> $

 $Date: 2012_04_19 $
 
}*/

#include "cc1101.h"

//{ Private Defines/ TypeDefs ****************************************************


//}  Private Defines
//{ Includes *************************************************************



//} Includes
//{ Private Structures/ Enums ****************************************************

//} Private Structures/ Enums
//{ Global Variables *****************************************************

radio_cc1101_SPIx_e radio_cc1101_SPIx;

ttc_Port_t radio_cc1101_Port_NSS;
ttc_Port_t radio_cc1101_Port_IRQ;

//} Global Variables
//{ Private Function prototypes **************************************************


//} Private Function prototypes

//{ Implemented Functions **************************************************

void radio_cc1101_Init(radio_cc1101_SPIx_e SPIx){

    radio_cc1101_SPIx = SPIx;
    ttc_spi_generic_t* SPI_Generic;
    stm32_spi_architecture_t* SPI_Arch;

    ttc_initPort2(&radio_cc1101_Port_NSS, GPIOB, 4, tgm_output_push_pull, tgs_Min);


  //  stm32w_initSPI(SC1,SPI_Generic ,SPI_Arch )   ;
    if(ttc_initSPI(SC1,SPI_Generic, SPI_Arch) != tue_OK){
        Assert(0,ec_UNKNOWN);
    }









//#ifdef radio_cc1101_STM32W
//    STM32W_SPIx_e STM32W_SPIx;
//    if(radio_cc1101_SPIx == radio_cc1101_SPI1){
//        STM32W_SPIx =  STM32W_SPI1;
//    }else if(radio_cc1101_SPIx == radio_cc1101_SPI2){
//        STM32W_SPIx =  STM32W_SPI2;
//    }else{

//        return;
//    }


//    STM32W_SPI_Init(STM32W_SPIx);

//#else
//    //put STM32F10x init here
//     //   #error "You must select a microcontroller STM32W or STM32F1x supported"
//#endif


}
void radio_cc1101_Configure(radio_cc1101_Configuration_t radio_cc1101_Configuration){}
radio_cc1101_PowerStatus_t radio_cc1101_PowerStatus_get(void){}
void radio_cc1101_PowerStatus_set(radio_cc1101_PowerStatus_t radio_cc1101_PowerStatus){}
void radio_cc1101_Register_set(u8_t addr, u8_t * data){

    //  DESCRIPTION:
    //    Write data to device, starting at internal device address "addr".
    //    The device will increment the address internally for every new byte
    //    that is written. For single byte write, set length to 1.








}
void radio_cc1101_Register_get(u8_t addr, u8_t * data){

    //  DESCRIPTION:
    //    Read data from device, starting at internal device address "addr".
    //    The device will increment the address internally for every new byte
    //    that is read. Note that the master device needs to write a dummy byte
    //    (in this case 0) for every new byte in order to generate the clock to
    //    clock out the data. For single byte read, set length to 1.



}

void radio_cc1101_receive_data(u8_t addr, u8_t * data, u32_t length){





}
void radio_cc1101_send_data(const char * data, u32_t length){


    ttc_portClr(&radio_cc1101_Port_NSS);

    ttc_sendRaw(SC1,data,length);
    ttc_portSet(&radio_cc1101_Port_NSS);

//#ifdef radio_cc1101_STM32W
//    STM32W_SPIx_e STM32W_SPIx;
//    if(radio_cc1101_SPIx == radio_cc1101_SPI1){
//        STM32W_SPIx =  STM32W_SPI1;
//    }else if(radio_cc1101_SPIx == radio_cc1101_SPI2){
//        STM32W_SPIx =  STM32W_SPI2;
//    }else{

//        return;
//    }

//    STM32W_SPI_send(STM32W_SPIx,data,length);
//#else
//   // #error "You must select a microcontroller STM32W or STM32F1x supported"
//    //put code for STM32F1x here
//#endif





}
void radio_cc1101_receive_data_ISR_Handler(void){}

//evtl Task der Modem überwacht
void radio_cc1101_Modem_Monitor_Task(void){


    while(1){}


}

//} Implemented Functions
