/*{ ttc_radio::.c ************************************************
 
                      The ToolChain
                      
   Device independent support for 
   
   
   written by Gregor Rebel 2012
   
 
}*/

#include "ttc_radio.h"

//{ Function definitions *************************************************

inline                  u8_t ttc_radio_get_max_index() {

    return TTC_AMOUNT_RADIOS; // -> ttc_radio_types.h
}
inline ttc_radio_errorcode_e ttc_radio_get_defaults(u8_t RADIO_Index, ttc_radio_generic_t* RADIO_Generic) {
    memset(RADIO_Generic, 0, sizeof(RADIO_Generic));
    
#ifdef TARGET_RADIO_CC1101
    return cc1101_radio_get_defaults(RADIO_Index, RADIO_Generic);
#endif

  return tse_NotImplemented;
}
inline ttc_radio_errorcode_e ttc_radio_get_features(u8_t RADIO_Index, ttc_radio_generic_t* RADIO_Generic) {
    memset(RADIO_Generic, 0, sizeof(RADIO_Generic));
    
#ifdef TARGET_RADIO_CC1101
    return cc1101_radio_get_features(RADIO_Index, RADIO_Generic);
#endif

  return tse_NotImplemented;
}
inline ttc_radio_errorcode_e ttc_radio_init(u8_t RADIO_Index, ttc_radio_generic_t* RADIO_Generic, ttc_radio_architecture_t* RADIO_Arch) {
    memset(RADIO_Arch, 0, sizeof(RADIO_Arch));

#ifdef TARGET_RADIO_CC1101
  return cc1101_radio_init(RADIO_Index, RADIO_Generic, (cc1101_radio_architecture_t*) RADIO_Arch);
#endif

  return tse_NotImplemented;
}
inline ttc_radio_errorcode_e ttc_radio_send_raw(u8_t RADIO_Index, const u8_t* Buffer, u16_t Amount) {
  
#ifdef TARGET_RADIO_CC1101
  return cc1101_radio_send_raw(RADIO_Index, Buffer, Amount);
#endif

  return tse_NotImplemented;
}
inline ttc_radio_errorcode_e ttc_radio_send_string(u8_t RADIO_Index, const u8_t* Buffer, u16_t MaxLength) {
  
#ifdef TARGET_RADIO_CC1101
  return cc1101_radio_send_string(RADIO_Index, Buffer, MaxLength);
#endif

  return tse_NotImplemented;
}
inline ttc_radio_errorcode_e ttc_radio_read_byte(u8_t RADIO_Index, u8_t* Byte, u32_t TimeOut) {

#ifdef TARGET_RADIO_CC1101
  return cc1101_radio_read_byte(RADIO_Index, Byte, TimeOut);
#endif

  return tse_NotImplemented;
}
inline ttc_radio_errorcode_e ttc_radio_getbytes(u8_t RADIO_Index, u8_t** Buffer, u16_t* Amount) {

#ifdef TARGET_RADIO_CC1101
  return cc1101_radio_read_byte(RADIO_Index, Buffer, Amount);
#endif

  return tse_NotImplemented;
}
inline ttc_radio_errorcode_e ttc_radio_register_rx_function(u8_t RADIO_Index, void*RxFunction(u8_t), u8_t EOM_Character, ttc_radio_signal_mode_e Mode) {

#ifdef TARGET_RADIO_CC1101
  return ttc_radio_register_rx_function(RADIO_Index, RxFunction, EOM_Character, Mode);
#endif

  return tse_NotImplemented;
  
}

//} Function definitions
