#ifndef TTC_RADIO_TYPES_H
#define TTC_RADIO_TYPES_H

/*{ ttc_radio_types.h ***********************************************
 *
 * Written by Gregor Rebel 2010-2012
 *
 * Basic defines, enums and structures.
 *
 * Include this file from 
 * architecture independent header files (ttc_XXX.h) and 
 * architecture depend      header files (e.g. stm32_XXX.h)
 * 
}*/

#include "ttc_basic.h"

//{ Defines/ TypeDefs ****************************************************

//{ TTC_RADIOn has to be defined as constant by makefile.100_board_*
#ifdef TTC_RADIO5
  #ifndef TTC_RADIO4
    #error TTC_RADIO5 is defined, but not TTC_RADIO4 - all lower TTC_RADIOn must be defined!
  #endif
  #ifndef TTC_RADIO3
    #error TTC_RADIO5 is defined, but not TTC_RADIO3 - all lower TTC_RADIOn must be defined!
  #endif
  #ifndef TTC_RADIO2
    #error TTC_RADIO5 is defined, but not TTC_RADIO2 - all lower TTC_RADIOn must be defined!
  #endif
  #ifndef TTC_RADIO1
    #error TTC_RADIO5 is defined, but not TTC_RADIO1 - all lower TTC_RADIOn must be defined!
  #endif

  #define TTC_AMOUNT_RADIOS 5
#else
  #ifdef TTC_RADIO4
    #define TTC_AMOUNT_RADIOS 4

    #ifndef TTC_RADIO3
      #error TTC_RADIO5 is defined, but not TTC_RADIO3 - all lower TTC_RADIOn must be defined!
    #endif
    #ifndef TTC_RADIO2
      #error TTC_RADIO5 is defined, but not TTC_RADIO2 - all lower TTC_RADIOn must be defined!
    #endif
    #ifndef TTC_RADIO1
      #error TTC_RADIO5 is defined, but not TTC_RADIO1 - all lower TTC_RADIOn must be defined!
    #endif
  #else
    #ifdef TTC_RADIO3
    
      #ifndef TTC_RADIO2
        #error TTC_RADIO5 is defined, but not TTC_RADIO2 - all lower TTC_RADIOn must be defined!
      #endif
      #ifndef TTC_RADIO1
        #error TTC_RADIO5 is defined, but not TTC_RADIO1 - all lower TTC_RADIOn must be defined!
      #endif
    
      #define TTC_AMOUNT_RADIOS 3
    #else
      #ifdef TTC_RADIO2

        #ifndef TTC_RADIO1
          #error TTC_RADIO5 is defined, but not TTC_RADIO1 - all lower TTC_RADIOn must be defined!
        #endif

        #define TTC_AMOUNT_RADIOS 2
      #else
        #ifdef TTC_RADIO1
          #define TTC_AMOUNT_RADIOS 1
        #else
          #define TTC_AMOUNT_RADIOS 0
        #endif
      #endif
    #endif
  #endif
#endif
//}

//} Defines
//{ Structures/ Enums 1 **************************************************


typedef enum {   // ttc_spi_errorcode_e
  tse_OK,                // =0: no error
  tse_TimeOut,           // timeout occured in called function
  tse_DeviceNotFound,    // adressed SPI device not available in current uC
  tse_NotImplemented,    // function has no implementation for current architecture
  tse_InvalidArgument,   // general argument error
  tse_DeviceNotReady,    // choosen device has not been initialized properly
  
  tse_UnknownError
} ttc_spi_errorcode_e;

typedef enum {   // ttc_radio_errorcode_e ->ttc_radio_register_rx_function()
   trsm_Signal_OnEveryByte,     // call RxFunction() whenever a byte is received
   trsm_Signal_IfRxBufferFull,  // call RxFunction() only when one receive buffer is completely full
   trsm_Signal_On_EOM           // call RxFunction() when a special EOM character has been received
} ttc_radio_signal_mode_e;

//}

#endif // TTC_RADIO_TYPES_H
